package org.example.SnakeGame;

import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.example.game.Direction;

import java.util.ArrayList;
import java.util.List;

public class Snake extends Circle {

    private final static Logger log = LogManager.getLogger(Snake.class);
    private List<Circle> tails;
    private int length = 0;
    private Direction currentDirection;
    private static final int step = 8;

    public Snake(double d, double d1, double d2){
        super (d, d1, d2);
        tails = new ArrayList<>();
        currentDirection = Direction.UP;
    }
    public void step(){
        for (int i = length-1; i>=0; i--){
            if (i == 0){
                tails.get(i).setCenterX(getCenterX());
                tails.get(i).setCenterY(getCenterY());
            }
            else{
                tails.get(i).setCenterX(tails.get(i -1).getCenterX());
                tails.get(i).setCenterY(tails.get(i -1).getCenterY());
            }
        }

        if (currentDirection == Direction.UP){
            log.info("Snake moves UP");
            setCenterY(getCenterY()- step);
        }
        else if (currentDirection == Direction.DOWN){
            log.info("Snake moves DOWN");
            setCenterY(getCenterY() + step);
        }
        else if (currentDirection == Direction.LEFT) {
            log.info("Snake moves LEFT");
            setCenterX(getCenterX() - step);
        }
        else if (currentDirection == Direction.RIGHT) {
            log.info("Snake moves RIGHT");
            setCenterX(getCenterX() + step);
        }
    }

    public boolean eatSelf(){
        for (int i = 0; i < length; i++){
            if ((this.getCenterX() == tails.get(i).getCenterX()) && this.getCenterY() == tails.get(i).getCenterY()){
                return true;
            }
        }
        return false;
    }
    public int getLength(){
        return length;
    }
    public void setCurrentDirection(Direction currentDirection){

        this.currentDirection = currentDirection;
    }

    private Circle endTail(){
       if (length ==0){
           return this;
       }
       return tails.get(length -1);
    }
    public void eat(Circle food){
     Circle tail = endTail();
     food.setCenterX(tail.getCenterX());
     food.setCenterY(tail.getCenterY());
     food.setFill(Color.BLACK);
        tails.add(length++, food);
    }
}
