package org.example.StartScreen;

import javafx.application.Application;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.stage.Stage;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.util.Objects;


public class StartScreen extends Application {
        private final static Logger log = LogManager.getLogger(StartScreen.class);

        public static Stage stages;
        private final static double WIDTH = 600;
        private final static double HEIGHT = 500;


    public static void changeScene (String fxml, String css)  {
        try {
            FXMLLoader loader = new FXMLLoader();
            loader.load(StartScreen.class.getResourceAsStream(fxml));
            Scene scene = new Scene(loader.getRoot(), StartScreen.WIDTH, StartScreen.HEIGHT);
            scene.getStylesheets().add(Objects.requireNonNull(StartScreen.class.getResource(css)).toExternalForm());
            stages.setScene(scene);
        }
        catch (Exception exception) {
            log.error("Scene failed to load" + exception);
            exception.printStackTrace();
        }
    }
    @Override
    public void start(Stage stage) throws Exception {
        stages=stage;
        stage.setResizable(false);
        stage.setTitle("Snake Game");
        changeScene("/fxml/start.fxml" , "/styles/styles.css");
        log.info("Application started");
        // Image icon= new Image(new FileInputStream("src/main/resources/images...png")); Icon screen
        //stage.getIcons().add(icon);  Icon screen

        stage.show();

    }


        @FXML
        public void openOptions() {
            log.info("Clicked :)");

        }

    }


